/*
 Code *with* scalar source.

  q = 2!!
 
 Adjust mu dynamically
 
 
*/



#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include <time.h>

#include <complex.h>


#define PI 3.1415926535897932384626433832795028841971693993751


#define Nmax  100 

#define power(x,n) pow(x,n)

double totv = 20. ;

int N ;


double amp, amp2 ;



double dv, scalvev, Tvev ;

double x[Nmax], Dmat[Nmax][Nmax], D2mat[Nmax][Nmax] ;

double aval ;

double Var[5*Nmax], NewVar[5*Nmax], OldVar[5*Nmax], Eqn[5*Nmax], Lich[5*Nmax][5*Nmax], InitVar[5*Nmax], EqnConst[8*Nmax] ;

double Lmat[(5*Nmax)*(5*Nmax)] ;

void calcm(double, double *, double *, double *,double *, double *, double *) ;
void setupCheb(void), readin(void), writeout(double, FILE *), writeoutgeo(double, FILE *), calcstep(double), calcLich(double), calcEqn(double,double *), calcEqnConst(double) ;
void linsolve(double *, double *) ;


int main(void)
{
    FILE *outfile, *geofile, *paramfile ;
    
    int ii, tt, iter, numsteps, skip, numwrites ;
    double v, buf ;
    
    double _Complex psi ;
    
    
    outfile = fopen("output.dat","w") ; paramfile = fopen("param.dat","w") ;
    
    geofile = fopen("geo.dat","w") ; 
    
    
    if(outfile==NULL || paramfile==NULL) {
        printf("\n\nProblem opening output files\n\n") ; 
        exit(1) ;
    }

    readin() ;

    setupCheb() ;
    
    buf = (double) N ;     fwrite(&buf,sizeof(double),1,paramfile) ;
    buf = (double) aval ;  fwrite(&buf,sizeof(double),1,paramfile) ;
    for(ii=0;ii<N;ii++)    fwrite(&x[ii],sizeof(double),1,paramfile) ;
    

/* 
 
 Used 0.1 for 40 points. Note: 0.1 for 34 pts gives osc in \mu - but 0.12 is fine!! Odd.    
 
 */
    
    /* For 34 points 
    
    dv = 0.12/((double) N) ;
  */
    
    
    /* For 40 points */
    
    dv = 0.1/((double) N) ;
    
     
    
    numsteps = ceil(totv/dv) ;
    
    skip = ceil(((double) numsteps)/1000.) ;
    
 

    /*  For scan - pos = -15 and t = 0.5 t_c 
     
     
    amp2 = 0. ;
    
    for(iter=0;iter<50;iter++) {
        
        amp2 = amp2 + 0.02 ;  
        
     */
     
    
    /*  For scan fine ??? 
     
     
     amp2 = 0.56 ;
     
     for(iter=0;iter<12;iter++) {
     
     amp2 = amp2 + 0.005 ;  
     
     */
     
    
    /*  For contour plot 0.44 for pos = -15 */
     
     
     amp2 = 0.44 ;
     
     for(iter=0;iter<1;iter++) {
     
         
     
  
          
    printf("amp = %7.3e,  amp2 = %7.3e\n",amp,amp2) ;

    buf = (double) amp ;   fwrite(&buf,sizeof(double),1,paramfile) ;
    buf = (double) amp2 ;  fwrite(&buf,sizeof(double),1,paramfile) ;
    fflush(paramfile) ;
    
        
    for(ii=0;ii<5*N;ii++) { Var[ii] = InitVar[ii] ;  OldVar[ii] = InitVar[ii] ; NewVar[ii] = InitVar[ii] ; }
        
    
    v = 0. ;
    numwrites=0;
    
    psi = 0. ; for(ii=0;ii<N;ii++) psi += Dmat[0][ii]*(Var[ii]    + _Complex_I*Var[N+ii]) ; 
    printf(" Initial :   v = 0.   < O > = %7.3f   < rho > = %7.3e   mu = %7.3e  arg = %7.3e\n",sqrt(pow(Var[1],2)+pow(Var[N+1],2))/x[1],Var[3*N+1]/x[1],Var[2*N],carg(psi)) ;
         
    
    for(tt=1;tt<numsteps;tt++) {
		
		// if(v>0.8 && v<1.3) dv = 0.05/((double) N) ; 
	          
        calcstep(v) ;
        
        calcEqnConst(v) ;
        
        v+=dv ;
                        
        if(tt%skip==0) {
                        
            psi = 0. ; for(ii=0;ii<N;ii++) psi += Dmat[0][ii]*(Var[ii]    + _Complex_I*Var[N+ii]) ; 
                        
            printf(" ii = %d :   v = %7.3f   < O > = %7.3f   < rho > = %7.3e  mu = %7.3e   arg = %7.3e     <O>/mu^2 = %7.3e\n",tt,v,sqrt(pow(Var[1],2)+pow(Var[N+1],2))/x[1],Var[3*N+1]/x[1],Var[2*N],carg(psi),sqrt(pow(Var[1],2)+pow(Var[N+1],2))/x[1]/pow(Var[2*N],2)) ;
            
            writeout(v,outfile) ; 
            
            writeoutgeo(v,geofile) ; 
            
            numwrites+=1 ;
            
        }
        
        for(ii=0;ii<5*N;ii++) {
            
            OldVar[ii] = Var[ii] ;
            
            Var[ii] = NewVar[ii] ;
            
        }    
        
    }
        
    buf = (double) numwrites ;   fwrite(&buf,sizeof(double),1,paramfile) ;    
    
    }
    
    
    fclose(outfile) ; fclose(paramfile) ;  fclose(geofile) ;


    
}



void readin(void)
{
    int ii, pos, chk ;
    FILE *infile ;
        
    infile = fopen("init.dat","r") ;
    
    if(infile==NULL) {
        printf("\n\nProblem opening file\n\n") ; 
        exit(1) ;
    }
    
    chk = fread(&N,sizeof(int),1,infile) ;
    chk += fread(&aval,sizeof(double),1,infile) ;
    
    printf("N = %d  ;  aval = %e\n",N,aval) ;
        
    for(ii=0;ii<N;ii++) chk += fread(&InitVar[ii],sizeof(double),1,infile) ;
    for(ii=0;ii<N;ii++) chk += fread(&InitVar[N+ii],sizeof(double),1,infile) ;
    for(ii=0;ii<N;ii++) chk += fread(&InitVar[2*N+ii],sizeof(double),1,infile) ;
    for(ii=0;ii<N;ii++) chk += fread(&InitVar[3*N+ii],sizeof(double),1,infile) ;
    for(ii=0;ii<N;ii++) chk += fread(&InitVar[4*N+ii],sizeof(double),1,infile) ;
    
    fclose(infile) ;
    
    if(chk!=2+5*N) {
        printf("\n\nProblem reading file - EOF encountered  chk = %d\n\n",chk) ; 
        exit(1) ;
    }
        
}



void writeout(double time, FILE *outfile)
{
    int ii, chk ;
    
    chk = 0 ;
    
    chk += fwrite(&time,sizeof(double),1,outfile) ;
	
	chk += fwrite(&Var[2*N],sizeof(double),1,outfile) ;
            
    for(ii=0;ii<N;ii++) chk += fwrite(&Var[ii],sizeof(double),1,outfile) ;
    for(ii=0;ii<N;ii++) chk += fwrite(&Var[N+ii],sizeof(double),1,outfile) ;
    for(ii=0;ii<N;ii++) chk += fwrite(&Var[2*N+ii],sizeof(double),1,outfile) ;
    for(ii=0;ii<N;ii++) chk += fwrite(&Var[3*N+ii],sizeof(double),1,outfile) ;
    for(ii=0;ii<N;ii++) chk += fwrite(&Var[4*N+ii],sizeof(double),1,outfile) ;

        
    for(ii=0;ii<N;ii++)    chk += fwrite(&EqnConst[ii],sizeof(double),1,outfile) ;
    for(ii=0;ii<N;ii++)    chk += fwrite(&EqnConst[N+ii],sizeof(double),1,outfile) ;
    for(ii=0;ii<N;ii++)     chk += fwrite(&EqnConst[2*N+ii],sizeof(double),1,outfile) ;
    for(ii=0;ii<N;ii++)     chk += fwrite(&EqnConst[3*N+ii],sizeof(double),1,outfile) ;
    for(ii=0;ii<N;ii++)     chk += fwrite(&EqnConst[4*N+ii],sizeof(double),1,outfile) ;
    for(ii=0;ii<N;ii++)     chk += fwrite(&EqnConst[5*N+ii],sizeof(double),1,outfile) ;
    for(ii=0;ii<N;ii++)     chk += fwrite(&EqnConst[6*N+ii],sizeof(double),1,outfile) ;
    for(ii=0;ii<N;ii++)     chk += fwrite(&EqnConst[7*N+ii],sizeof(double),1,outfile) ;
    
    
    fflush(outfile) ;
    
    if(chk!=2+13*N) {
        printf("\n\nProblem writing data to outfile\n\n") ; 
        exit(1) ;
    }
    
}




void writeoutgeo(double time, FILE *outfile)
{
    double v, z ;
    
    double t0[Nmax], t0z[Nmax], t1[Nmax], t1z[Nmax] ;
    
    double t[Nmax], tz[Nmax], tv[Nmax] ;    
    
    int ii, jj, chk ;

    
    for(ii=0;ii<N;ii++) {
        
        t0[ii] = Var[3*N+ii] ; 
        t1[ii] = NewVar[3*N+ii] ;  
        
    }
    
    
    for(ii=0;ii<N;ii++) {
        
        t0z[ii] = 0. ; t1z[ii] = 0. ; 
             
        for(jj=0;jj<N;jj++) {
            
           t0z[ii] += Dmat[ii][jj]*t0[jj] ; 
            t1z[ii] += Dmat[ii][jj]*t1[jj] ;
                        
        }
        
    }
    
    for(ii=0;ii<N;ii++) {
        
        t[ii] = 0.5*( t1[ii] + t0[ii] ) ;

        tz[ii] = 0.5*( t1z[ii] + t0z[ii] ) ;

        tv[ii] = ( t1[ii] - t0[ii] )/dv ;
        
    }        
    
    
    chk = 0 ;
    
    chk += fwrite(&time,sizeof(double),1,outfile) ;
   
    for(ii=0;ii<N;ii++) chk += fwrite(&t[ii],sizeof(double),1,outfile) ;
    for(ii=0;ii<N;ii++) chk += fwrite(&tz[ii],sizeof(double),1,outfile) ;
    for(ii=0;ii<N;ii++) chk += fwrite(&tv[ii],sizeof(double),1,outfile) ;
      
    fflush(outfile) ;
    
    if(chk!=1+3*N) {
        printf("\n\nProblem writing data to outfile\n\n") ; 
        exit(1) ;
    }
    
}



void calcm(double v, double *pr, double *prv, double *prvv, double *pi, double *piv, double *pivv) 
{
    double w, v0, p, pv, pvv ;
    
	double c1, c2 ;
	
    
    w = 33.2 ;
    
    v0 = 2. ;
    
    p = amp2*exp(-(w*power(v - v0,2))) ;
    pv = -2*amp2*(v - v0)*w*exp(-(w*power(v - v0,2))) ;
    pvv = 2*amp2*w*exp(-(w*power(v - v0,2)))*(-1 - 4*v*v0*w + 2*w*power(v,2) + 2*w*power(v0,2)) ;
    
	c1 = +1. ;  
	
	c2 = 0. ;
	
	*pr = c1*p ;
	*prv = c1*pv ;
	*prvv = c1*pvv ;
	
	*pi = c2*p ;
	*piv = c2*pv ;
	*pivv = c2*pvv ;
    
}



/*
 
 amp2 = -0.8 would give normal phase.

void calcm(double v, double *pr, double *prv, double *prvv, double *pi, double *piv, double *pivv) 
{
    double w, v0, p, pv, pvv ;
    
	double c1, c2 ;
	
    w  = 10. ;
    
    v0 = 2. ;
   
    p = amp2*exp(-(w*power(v - v0,2))) ;
    pv = -2*amp2*(v - v0)*w*exp(-(w*power(v - v0,2))) ;
    pvv = 2*amp2*w*exp(-(w*power(v - v0,2)))*(-1 - 4*v*v0*w + 2*w*power(v,2) + 2*w*power(v0,2)) ;
    
	c1 = 0. ;  
	
	c2 = -1. ;
	
	*pr = c1*p ;
	*prv = c1*pv ;
	*prvv = c1*pvv ;
	
	*pi = c2*p ;
	*piv = c2*pv ;
	*pivv = c2*pvv ;
     
}

 */


void calcstep(double time)
{
    int ii, iter ;
    double err ;
    
    double step[5*Nmax] ;
    
   	
	for(ii=0;ii<5*N;ii++) { NewVar[ii] = 2*Var[ii] - OldVar[ii] ; } ;
	    
    for(iter=0;iter<20;iter++) {
        
        calcEqn(time,Eqn) ;
        
        calcLich(time) ;
        
        linsolve(step,Eqn) ;
                
		for(ii=0;ii<5*N;ii++) NewVar[ii] -= step[ii] ;

		for(err=0.,ii=0;ii<5*N;ii++) { if(fabs(Eqn[ii])>err) err = fabs(Eqn[ii]) ; }
        
		
        // printf(" iter = %d  ->  err = %7.3e\n",iter,err) ;
        
        if(err<1e-5) break ;
		
    } 
    
    if(iter>15) { printf("   *** WARNING: Precision issue;   iter = %d,  err = %7.3e\n",iter,err) ; 
    
        if(err>1.) exit(1) ;
    
    }
    
    
}


void calcLich(double time)
{
    int ii, jj, kk ;
    double EqnM[5*Nmax], EqnP[5*Nmax] ;
    
    double store[5*Nmax] ;
    
    double delta = 1.e-6 ;
    
    
    
    for(ii=0;ii<5*N;ii++) store[ii] = NewVar[ii] ;
    
    calcEqn(time,Eqn) ;
    
    
    for(ii=0;ii<5*N;ii++) {
        
        NewVar[ii] = store[ii] + delta ;
        
        calcEqn(time,EqnP) ;
        
        NewVar[ii] = store[ii] - delta ;
        
        calcEqn(time,EqnM) ;
        
        NewVar[ii] = store[ii] ;

        for(jj=0;jj<5*N;jj++) {
            
            Lich[jj][ii] = ( EqnP[jj] - EqnM[jj] )/( 2*delta ) ;
            
        }
        
    }
    
    
}




void calcEqn(double time, double *eqnVec)
{
    int ii, jj, pos ;
    
    double v, z, pr, prv, prvv, pi, piv, pivv ;
    
    double f0[Nmax], f0z[Nmax], f0zz[Nmax], h0[Nmax], h0z[Nmax], h0zz[Nmax], a0[Nmax], a0z[Nmax], a0zz[Nmax], t0[Nmax], t0z[Nmax], t0zz[Nmax], s0[Nmax], s0z[Nmax], s0zz[Nmax] ;
    
    double f1[Nmax], f1z[Nmax], f1zz[Nmax], h1[Nmax], h1z[Nmax], h1zz[Nmax], a1[Nmax], a1z[Nmax], a1zz[Nmax], t1[Nmax], t1z[Nmax], t1zz[Nmax], s1[Nmax], s1z[Nmax], s1zz[Nmax] ;
    
    double f, h, a, t, s, fz, hz, az, tz, sz, fzz, hzz, azz, tzz, szz, fv, hv, av, tv, sv, fvz, hvz, avz, tvz, svz ;    
    
    
    v = time + 0.5*dv ;
    
    calcm(v, &pr, &prv, &prvv, &pi, &piv, &pivv) ; 
    
    
   
    
    for(ii=0;ii<N;ii++) {
        
        f0[ii] = Var[ii] ; h0[ii] = Var[N+ii] ; a0[ii] = Var[2*N+ii] ; t0[ii] = Var[3*N+ii] ; s0[ii] = Var[4*N+ii] ; 
        
        f1[ii] = NewVar[ii] ; h1[ii] = NewVar[N+ii] ; a1[ii] = NewVar[2*N+ii] ; t1[ii] = NewVar[3*N+ii] ; s1[ii] = NewVar[4*N+ii] ; 
        
    }
    
    
    for(ii=0;ii<N;ii++) {
        
        f0z[ii] = 0. ; h0z[ii] = 0. ; a0z[ii] = 0. ; t0z[ii] = 0. ; s0z[ii] = 0. ;
        f1z[ii] = 0. ; h1z[ii] = 0. ; a1z[ii] = 0. ; t1z[ii] = 0. ; s1z[ii] = 0. ;
        
        f0zz[ii] = 0. ; h0zz[ii] = 0. ; a0zz[ii] = 0. ; t0zz[ii] = 0. ; s0zz[ii] = 0. ;
        f1zz[ii] = 0. ; h1zz[ii] = 0. ; a1zz[ii] = 0. ; t1zz[ii] = 0. ; s1zz[ii] = 0. ;
        
        
        for(jj=0;jj<N;jj++) {
            
            f0z[ii] += Dmat[ii][jj]*f0[jj] ;
            h0z[ii] += Dmat[ii][jj]*h0[jj] ;
            a0z[ii] += Dmat[ii][jj]*a0[jj] ;
            t0z[ii] += Dmat[ii][jj]*t0[jj] ;
            s0z[ii] += Dmat[ii][jj]*s0[jj] ;
            
            f1z[ii] += Dmat[ii][jj]*f1[jj] ;
            h1z[ii] += Dmat[ii][jj]*h1[jj] ;
            a1z[ii] += Dmat[ii][jj]*a1[jj] ;
            t1z[ii] += Dmat[ii][jj]*t1[jj] ;
            s1z[ii] += Dmat[ii][jj]*s1[jj] ;
            
            f0zz[ii] += D2mat[ii][jj]*f0[jj] ;
            h0zz[ii] += D2mat[ii][jj]*h0[jj] ;
            a0zz[ii] += D2mat[ii][jj]*a0[jj] ;
            t0zz[ii] += D2mat[ii][jj]*t0[jj] ;
            s0zz[ii] += D2mat[ii][jj]*s0[jj] ;
            
            f1zz[ii] += D2mat[ii][jj]*f1[jj] ;
            h1zz[ii] += D2mat[ii][jj]*h1[jj] ;
            a1zz[ii] += D2mat[ii][jj]*a1[jj] ;
            t1zz[ii] += D2mat[ii][jj]*t1[jj] ;
            s1zz[ii] += D2mat[ii][jj]*s1[jj] ;
            
        }
        
    }
    
    
    
    double boundtvz, boundfvz, boundhvz, boundfz, boundhz, bounda ;
    
    boundfvz = ( f1z[0] - f0z[0] )/dv ;
	boundhvz = ( h1z[0] - h0z[0] )/dv ;
    boundtvz = ( t1z[0] - t0z[0] )/dv ;
    boundfz  = 0.5*( f1z[0] + f0z[0] ) ;
	boundhz  = 0.5*( h1z[0] + h0z[0] ) ;
    bounda   = 0.5*( a1[0] + a0[0] ) ;
    
    
    for(pos=0,ii=0;ii<N;ii++) {
        
        z = x[ii] ;
        
        f = 0.5*( f1[ii] + f0[ii] ) ;
        h = 0.5*( h1[ii] + h0[ii] ) ;
        a = 0.5*( a1[ii] + a0[ii] ) ;
        t = 0.5*( t1[ii] + t0[ii] ) ;
        s = 0.5*( s1[ii] + s0[ii] ) ;
        
        fz = 0.5*( f1z[ii] + f0z[ii] ) ;
        hz = 0.5*( h1z[ii] + h0z[ii] ) ;
        az = 0.5*( a1z[ii] + a0z[ii] ) ;
        tz = 0.5*( t1z[ii] + t0z[ii] ) ;
        sz = 0.5*( s1z[ii] + s0z[ii] ) ;
        
        fzz = 0.5*( f1zz[ii] + f0zz[ii] ) ;
        hzz = 0.5*( h1zz[ii] + h0zz[ii] ) ;
        azz = 0.5*( a1zz[ii] + a0zz[ii] ) ;
        tzz = 0.5*( t1zz[ii] + t0zz[ii] ) ;
        szz = 0.5*( s1zz[ii] + s0zz[ii] ) ;
        
        fv = ( f1[ii] - f0[ii] )/dv ;
        hv = ( h1[ii] - h0[ii] )/dv ;
        av = ( a1[ii] - a0[ii] )/dv ;
        tv = ( t1[ii] - t0[ii] )/dv ;
        sv = ( s1[ii] - s0[ii] )/dv ;
        
        fvz = ( f1z[ii] - f0z[ii] )/dv ;
        hvz = ( h1z[ii] - h0z[ii] )/dv ;
        avz = ( a1z[ii] - a0z[ii] )/dv ;
        tvz = ( t1z[ii] - t0z[ii] )/dv ;
        svz = ( s1z[ii] - s0z[ii] )/dv ;
        
        if(ii==0) {
            
            eqnVec[pos++] = f - pr ;
            
            eqnVec[pos++] = h - pi ;
            
    //        eqnVec[pos++] = a - aval ;
			
	//		eqnVec[pos++] = h1z[0] ; 
            
            eqnVec[pos++] = h1z[0] + 2*bounda*pr - piv ; 
            
             
           
            eqnVec[pos++] = s + 0.25*(pr*pr + pi*pi) ;
            
            eqnVec[pos++] = t + 0.5*(pr*pr + pi*pi) ;
            
        } else {
            
                        
			eqnVec[pos++] = fvz - (fzz - 2*az*h - 4*fv*s*z + 4*fz*s*z + 2*fz*t*z + fzz*s*power(z,2) - 2*az*h*s*power(z,2) - 2*fz*sv*power(z,2) - 2*fv*sz*power(z,2) + 2*fz*sz*power(z,2) + fzz*t*power(z,2) + fz*tz*power(z,2) - 4*a*(h*z*(2*s + sz*z) + hz*(1 + s*power(z,2))) + 6*fz*s*t*power(z,3) + f*(z*(-2*sv + tz + 2*sz*(1 + t*power(z,2))) + s*(4 + 4*t*power(z,2) + tz*power(z,3))) + fzz*s*t*power(z,4) + 2*fz*sz*t*power(z,4) + fz*s*tz*power(z,4))*power(2 + 2*s*power(z,2),-1) ; 
			
			eqnVec[pos++] = hvz - (2*az*f + hzz + 4*a*(f*z*(2*s + sz*z) + fz*(1 + s*power(z,2))) + h*(z*(-2*sv + tz + 2*sz*(1 + t*power(z,2))) + s*(4 + 4*t*power(z,2) + tz*power(z,3))) + z*(2*hz*t + 2*az*f*s*z - 2*hz*sv*z - 2*hv*sz*z + 2*hz*sz*z + hzz*t*z + hz*tz*z + 2*hz*sz*t*power(z,3) + s*(-4*hv + hzz*(z + t*power(z,3)) + hz*(4 + 6*t*power(z,2) + tz*power(z,3)))))*power(2 + 2*s*power(z,2),-1) ; 
			
			eqnVec[pos++] = avz - (-2*az*sv*power(z,2) - 4*(1 + s*power(z,2))*(2*a*(power(f,2) + power(h,2)) + h*(fv - fz*(1 + t*power(z,2))) + f*(-hv + hz*(1 + t*power(z,2)))))*power(1 + s*power(z,2),-1) ; 
			
            
			if(ii==1) {
                
//                 eqnVec[pos++] = boundtvz + 2*bounda*p*(boundhz + 2*bounda*p) + p*boundfvz - p*pvv ;
				
				eqnVec[pos++] = boundtvz + 2*bounda*( pr*boundhz - pi*boundfz + 2*( pi*prv - pr*piv )) + 4*bounda*bounda*(pr*pr + pi*pi) + pr*boundfvz + pi*boundhvz - pr*prvv - pi*pivv ;
				
            } else {
				
				eqnVec[pos++] = tzz + (12*s - 2*t + z*(2*(-2*sv + 6*sz + tz) + z*(-power(az,2) + 2*(-(fv*fz) - hv*hz + szz + power(hz,2) - sz*(-2*sv + sz)*power(z,2) + power(fz,2)*(1 + t*power(z,2)) + t*z*(6*sz + z*(szz + power(hz,2) - power(sz,2)*power(z,2)))) + 2*s*(z*(2*(sv + sz + tz) + z*(2*fz*(-fv + fz) + 2*hz*(-hv + hz) + szz - power(az,2))) + t*(4 + (szz*z + 2*(sz + z*(power(fz,2) + power(hz,2))))*power(z,3))) + power(s,2)*(4 + (-(z*power(az,2)) + 2*(tz + z*(-(fv*fz) - hv*hz + power(fz,2) + power(hz,2))))*power(z,3) + 2*t*(power(z,2) + (power(fz,2) + power(hz,2))*power(z,6))))) + 2*power(f,2)*(1 + t*power(z,2))*power(1 + s*power(z,2),2) + 2*power(h,2)*(1 + t*power(z,2))*power(1 + s*power(z,2),2) + 2*f*z*(-fv + 2*a*hz*z + 2*fz*(1 + t*power(z,2)))*power(1 + s*power(z,2),2) + 2*h*z*(-hv - 2*a*fz*z + 2*hz*(1 + t*power(z,2)))*power(1 + s*power(z,2),2))*power(z + s*power(z,3),-2) ; 

            }
			
			eqnVec[pos++] = svz + (power(z,-4)*(1 + s*power(z,2))*(12 + 4*(2*t + tz*z)*power(z,2) + 4*power(f,2)*power(z,2) + 4*power(h,2)*power(z,2) - power(az,2)*power(z,4) + 2*(1 + t*power(z,2))*(-6 + power(z,2)*power(f + fz*z,2) + power(z,2)*power(h + hz*z,2)) - 4*(2*s + sz*z)*(-2*sv*z + (2*s + sz*z)*(1 + t*power(z,2)))*power(z,4)*power(1 + s*power(z,2),-2) + 16*(2*s + sz*z)*power(z,2)*(1 + t*power(z,2))*power(1 + s*power(z,2),-1) - 4*(2*s + sz*z)*(2*t + tz*z)*power(z,4)*power(1 + s*power(z,2),-1)))/8. ; 


            
            
        }
        
    }
    
    
}




void calcEqnConst(double time)
{
    int ii, jj ;
    
    double v, z, pr, prv, prvv, pi, piv, pivv ;
    
    double f0[Nmax], f0z[Nmax], f0zz[Nmax], h0[Nmax], h0z[Nmax], h0zz[Nmax], a0[Nmax], a0z[Nmax], a0zz[Nmax], t0[Nmax], t0z[Nmax], t0zz[Nmax], s0[Nmax], s0z[Nmax], s0zz[Nmax] ;

    double f1[Nmax], f1z[Nmax], f1zz[Nmax], h1[Nmax], h1z[Nmax], h1zz[Nmax], a1[Nmax], a1z[Nmax], a1zz[Nmax], t1[Nmax], t1z[Nmax], t1zz[Nmax], s1[Nmax], s1z[Nmax], s1zz[Nmax] ;

    double f2[Nmax], f2z[Nmax], f2zz[Nmax], h2[Nmax], h2z[Nmax], h2zz[Nmax], a2[Nmax], a2z[Nmax], a2zz[Nmax], t2[Nmax], t2z[Nmax], t2zz[Nmax], s2[Nmax], s2z[Nmax], s2zz[Nmax] ;
    
    double f, h, a, t, s, fz, hz, az, tz, sz, fzz, hzz, azz, tzz, szz, fv, hv, av, tv, sv, fvz, hvz, avz, tvz, svz, fvv, hvv, avv, tvv, svv ;    
    
    
    v = time ;
    
    calcm(v, &pr, &prv, &prvv, &pi, &piv, &pivv) ; 
    
    
    for(ii=0;ii<N;ii++) {
        
        f0[ii] = OldVar[ii] ; h0[ii] = OldVar[N+ii] ; a0[ii] = OldVar[2*N+ii] ; t0[ii] = OldVar[3*N+ii] ; s0[ii] = OldVar[4*N+ii] ; 
        
        f1[ii] = Var[ii] ; h1[ii] = Var[N+ii] ; a1[ii] = Var[2*N+ii] ; t1[ii] = Var[3*N+ii] ; s1[ii] = Var[4*N+ii] ; 
        
        f2[ii] = NewVar[ii] ; h2[ii] = NewVar[N+ii] ; a2[ii] = NewVar[2*N+ii] ; t2[ii] = NewVar[3*N+ii] ; s2[ii] = NewVar[4*N+ii] ; 
        
    }
    
    
    for(ii=0;ii<N;ii++) {
        
        f0z[ii] = 0. ; h0z[ii] = 0. ; a0z[ii] = 0. ; t0z[ii] = 0. ; s0z[ii] = 0. ;
        f1z[ii] = 0. ; h1z[ii] = 0. ; a1z[ii] = 0. ; t1z[ii] = 0. ; s1z[ii] = 0. ;
        f2z[ii] = 0. ; h2z[ii] = 0. ; a2z[ii] = 0. ; t2z[ii] = 0. ; s2z[ii] = 0. ;
        
        f0zz[ii] = 0. ; h0zz[ii] = 0. ; a0zz[ii] = 0. ; t0zz[ii] = 0. ; s0zz[ii] = 0. ;
        f1zz[ii] = 0. ; h1zz[ii] = 0. ; a1zz[ii] = 0. ; t1zz[ii] = 0. ; s1zz[ii] = 0. ;
        f2zz[ii] = 0. ; h2zz[ii] = 0. ; a2zz[ii] = 0. ; t2zz[ii] = 0. ; s2zz[ii] = 0. ;

        
        for(jj=0;jj<N;jj++) {
            
            f0z[ii] += Dmat[ii][jj]*f0[jj] ;
            h0z[ii] += Dmat[ii][jj]*h0[jj] ;
            a0z[ii] += Dmat[ii][jj]*a0[jj] ;
            t0z[ii] += Dmat[ii][jj]*t0[jj] ;
            s0z[ii] += Dmat[ii][jj]*s0[jj] ;
            
            f1z[ii] += Dmat[ii][jj]*f1[jj] ;
            h1z[ii] += Dmat[ii][jj]*h1[jj] ;
            a1z[ii] += Dmat[ii][jj]*a1[jj] ;
            t1z[ii] += Dmat[ii][jj]*t1[jj] ;
            s1z[ii] += Dmat[ii][jj]*s1[jj] ;
            
            f2z[ii] += Dmat[ii][jj]*f2[jj] ;
            h2z[ii] += Dmat[ii][jj]*h2[jj] ;
            a2z[ii] += Dmat[ii][jj]*a2[jj] ;
            t2z[ii] += Dmat[ii][jj]*t2[jj] ;
            s2z[ii] += Dmat[ii][jj]*s2[jj] ;
            
            f0zz[ii] += D2mat[ii][jj]*f0[jj] ;
            h0zz[ii] += D2mat[ii][jj]*h0[jj] ;
            a0zz[ii] += D2mat[ii][jj]*a0[jj] ;
            t0zz[ii] += D2mat[ii][jj]*t0[jj] ;
            s0zz[ii] += D2mat[ii][jj]*s0[jj] ;
            
            f1zz[ii] += D2mat[ii][jj]*f1[jj] ;
            h1zz[ii] += D2mat[ii][jj]*h1[jj] ;
            a1zz[ii] += D2mat[ii][jj]*a1[jj] ;
            t1zz[ii] += D2mat[ii][jj]*t1[jj] ;
            s1zz[ii] += D2mat[ii][jj]*s1[jj] ;
            
            f2zz[ii] += D2mat[ii][jj]*f2[jj] ;
            h2zz[ii] += D2mat[ii][jj]*h2[jj] ;
            a2zz[ii] += D2mat[ii][jj]*a2[jj] ;
            t2zz[ii] += D2mat[ii][jj]*t2[jj] ;
            s2zz[ii] += D2mat[ii][jj]*s2[jj] ;

        }

    }

    
    for(ii=0;ii<N;ii++) {
    
        z = x[ii] ;
        
        f = f1[ii] ;
        h = h1[ii] ;
        a = a1[ii] ;
        t = t1[ii] ;
        s = s1[ii] ;
        
        fz = f1z[ii] ;
        hz = h1z[ii] ;
        az = a1z[ii] ;
        tz = t1z[ii] ;
        sz = s1z[ii] ;

        fzz = f1zz[ii] ;
        hzz = h1zz[ii] ;
        azz = a1zz[ii] ;
        tzz = t1zz[ii] ;
        szz = s1zz[ii] ;

        fv = ( f2[ii] - f0[ii] )/(2*dv) ;
        hv = ( h2[ii] - h0[ii] )/(2*dv) ;
        av = ( a2[ii] - a0[ii] )/(2*dv) ;
        tv = ( t2[ii] - t0[ii] )/(2*dv) ;
        sv = ( s2[ii] - s0[ii] )/(2*dv) ;
        
        fvz = ( f2z[ii] - f0z[ii] )/(2*dv) ;
        hvz = ( h2z[ii] - h0z[ii] )/(2*dv) ;
        avz = ( a2z[ii] - a0z[ii] )/(2*dv) ;
        tvz = ( t2z[ii] - t0z[ii] )/(2*dv) ;
        svz = ( s2z[ii] - s0z[ii] )/(2*dv) ;
        
        fvv = ( f2[ii] + f0[ii] - 2*f1[ii] )/(dv*dv) ;
        hvv = ( h2[ii] + h0[ii] - 2*h1[ii] )/(dv*dv) ;
        avv = ( a2[ii] + a0[ii] - 2*a1[ii] )/(dv*dv) ;
        tvv = ( t2[ii] + t0[ii] - 2*t1[ii] )/(dv*dv) ;
        svv = ( s2[ii] + s0[ii] - 2*s1[ii] )/(dv*dv) ;

        
        if(ii==0) {
            
            EqnConst[ii] = 0.;
            
			EqnConst[N+ii] = 0.;
			
			EqnConst[2*N+ii] = 0.;
			
			EqnConst[3*N+ii] = 0.;
			
			EqnConst[4*N+ii] = 0.;
			
			EqnConst[5*N+ii] = 0.;
			
			EqnConst[6*N+ii] = 0.;
			
			EqnConst[7*N+ii] = 0.;
            
        } else {
			
			EqnConst[ii] = -(power(1 + s*power(z,2),-2)*(-4*power(z,3)*(2*svz*z*(1 + s*power(z,2)) + sv*(1 + 3*s*power(z,2) + sz*power(z,3))) + 4*power(z,2)*(1 + s*power(z,2))*(2*s*(-2 + tz*power(z,3)) + z*(szz*z*(1 + t*power(z,2)) + sz*(1 + 3*t*power(z,2) + tz*power(z,3)))) + 2*(1 + t*power(z,2))*power(z,4)*power(2*s + sz*z,2) + (12 + 2*t*power(z,2) - 2*tz*power(z,3) + tzz*power(z,4))*power(1 + s*power(z,2),2))) ; 
			
			EqnConst[N+ii] = hvz - (2*az*f + hzz + 4*a*(f*z*(2*s + sz*z) + fz*(1 + s*power(z,2))) + h*(z*(-2*sv + tz + 2*sz*(1 + t*power(z,2))) + s*(4 + 4*t*power(z,2) + tz*power(z,3))) + z*(2*hz*t + 2*az*f*s*z - 2*hz*sv*z - 2*hv*sz*z + 2*hz*sz*z + hzz*t*z + hz*tz*z + 2*hz*sz*t*power(z,3) + s*(-4*hv + hzz*(z + t*power(z,3)) + hz*(4 + 6*t*power(z,2) + tz*power(z,3)))))*power(2 + 2*s*power(z,2),-1) ; 
			
			EqnConst[2*N+ii] = avz - (-2*az*sv*power(z,2) - 4*(1 + s*power(z,2))*(2*a*(power(f,2) + power(h,2)) + h*(fv - fz*(1 + t*power(z,2))) + f*(-hv + hz*(1 + t*power(z,2)))))*power(1 + s*power(z,2),-1) ; 
			
			EqnConst[3*N+ii] = tzz + (12*s - 2*t + z*(2*(-2*sv + 6*sz + tz) + z*(-power(az,2) + 2*(-(fv*fz) - hv*hz + szz + power(hz,2) - sz*(-2*sv + sz)*power(z,2) + power(fz,2)*(1 + t*power(z,2)) + t*z*(6*sz + z*(szz + power(hz,2) - power(sz,2)*power(z,2)))) + 2*s*(z*(2*(sv + sz + tz) + z*(2*fz*(-fv + fz) + 2*hz*(-hv + hz) + szz - power(az,2))) + t*(4 + (szz*z + 2*(sz + z*(power(fz,2) + power(hz,2))))*power(z,3))) + power(s,2)*(4 + (-(z*power(az,2)) + 2*(tz + z*(-(fv*fz) - hv*hz + power(fz,2) + power(hz,2))))*power(z,3) + 2*t*(power(z,2) + (power(fz,2) + power(hz,2))*power(z,6))))) + 2*power(f,2)*(1 + t*power(z,2))*power(1 + s*power(z,2),2) + 2*power(h,2)*(1 + t*power(z,2))*power(1 + s*power(z,2),2) + 2*f*z*(-fv + 2*a*hz*z + 2*fz*(1 + t*power(z,2)))*power(1 + s*power(z,2),2) + 2*h*z*(-hv - 2*a*fz*z + 2*hz*(1 + t*power(z,2)))*power(1 + s*power(z,2),2))*power(z + s*power(z,3),-2) ; 
			
			EqnConst[4*N+ii] = svz + (power(z,-4)*(1 + s*power(z,2))*(12 + 4*(2*t + tz*z)*power(z,2) + 4*power(f,2)*power(z,2) + 4*power(h,2)*power(z,2) - power(az,2)*power(z,4) + 2*(1 + t*power(z,2))*(-6 + power(z,2)*power(f + fz*z,2) + power(z,2)*power(h + hz*z,2)) - 4*(2*s + sz*z)*(-2*sv*z + (2*s + sz*z)*(1 + t*power(z,2)))*power(z,4)*power(1 + s*power(z,2),-2) + 16*(2*s + sz*z)*power(z,2)*(1 + t*power(z,2))*power(1 + s*power(z,2),-1) - 4*(2*s + sz*z)*(2*t + tz*z)*power(z,4)*power(1 + s*power(z,2),-1)))/8. ; 
			
			EqnConst[5*N+ii] = szz + (power(z,-2)*(4*s + 8*sz*z + 2*f*fz*z*(1 + s*power(z,2)) + power(f,2)*(1 + s*power(z,2)) + (1 + s*power(z,2))*(power(fz,2)*power(z,2) + power(h + hz*z,2))))/2. ; 
			
			EqnConst[6*N+ii] = azz + 2*(-2*fz*h + 2*f*hz + 2*s*z*(az - fz*h*z + f*hz*z) + az*sz*power(z,2))*power(1 + s*power(z,2),-1) ; 
			
			EqnConst[7*N+ii] = svv + ((32*s - 4*t + 4*f*z*(-4*a*hv*z + (1 + t*power(z,2))*(-fv + 2*a*hz*z + fz*(1 + t*power(z,2))))*power(1 + s*power(z,2),2) + 4*h*z*(2*a*z*(2*fv - fz*(1 + t*power(z,2))) + (1 + t*power(z,2))*(-hv + hz*(1 + t*power(z,2))))*power(1 + s*power(z,2),2) + 2*power(f,2)*(3 + power(z,2)*(8*power(a,2) + t*(4 + t*power(z,2))))*power(1 + s*power(z,2),2) + 2*power(h,2)*(3 + power(z,2)*(8*power(a,2) + t*(4 + t*power(z,2))))*power(1 + s*power(z,2),2) + z*(4*(-4*sv + 4*sz + tv + tz) + z*(-power(az,2) + 2*(power(fz,2) + power(hz,2)) - 4*(fv*(-fv + fz) + hv*(-hv + hz) + (-(sv*tz) + sz*(-2*sv + tv + tz) + power(sz,2))*power(z,2)) - t*z*(-4*(-2*sv + 6*sz + tz) + z*(power(az,2) + 4*((fv - fz)*fz + (hv - hz)*hz + sz*(-2*sv + 2*sz + tz)*power(z,2)))) + s*(-2*power(z,2)*(power(az,2) - 2*(-2*fv*fz - 2*hv*hz + power(fz,2) + 2*(power(fv,2) + power(hv,2)) + power(hz,2) + (sv*tz - sz*(tv + tz))*power(z,2))) + 4*power(t,2)*power(z,2)*(2 + (-2*sz + z*(power(fz,2) + power(hz,2)))*power(z,3)) - 2*t*(-20 + (4*(-sv + sz) + z*(4*(fv - fz)*fz + 4*(hv - hz)*hz + power(az,2) + 2*sz*tz*power(z,2)))*power(z,3))) + power(s,2)*(16 - (4*(tv + tz) + z*(power(az,2) - 2*(-2*fv*fz - 2*hv*hz + power(fz,2) + 2*(power(fv,2) + power(hv,2)) + power(hz,2))))*power(z,3) - t*power(z,2)*(-12 + (z*power(az,2) + 4*(tz + fv*fz*z + (hv - hz)*hz*z - z*power(fz,2)))*power(z,3)) + 2*power(t,2)*power(z,4)*(-2 + (power(fz,2) + power(hz,2))*power(z,4))) + 2*power(t,2)*(power(fz,2)*power(z,4) + power(hz,2)*power(z,4) - 2*power(-1 + sz*power(z,3),2)))))*power(power(z,2) + s*power(z,4),-1))/8. ; 
			
		}
        
    }
    
    
}









void setupCheb(void)
{
    int ii, jj, kk ;
    
    
    /* Std - for r  */
    
    for(ii=0;ii<N;ii++) {
        
        x[ii] = (1 + cos(PI*(((double) (N-ii))-1)/(((double) N)-1)) )/2 ;
        
    }
    
    for(ii=1;ii<N-1;ii++) {
		for(jj=1;jj<N-1;jj++) {
            
            if(ii==jj) 
                Dmat[ii][jj] = - (x[jj] - 0.5)/(2*(1-x[jj])*x[jj]) ;
            else
                Dmat[ii][jj] = ((double) pow(-1,ii+jj))/( x[ii] - x[jj] ) ;
            
        }
    }
    
    Dmat[0][0] = - ( 2*((double) pow(N-1,2)) + 1 )/3 ;
    
    for(jj=1;jj<N-1;jj++) {
        
        Dmat[0][jj] = -2*((double) pow(-1.,jj))/x[jj] ;
        
    }
    
    Dmat[0][N-1] = - pow(-1,N-1) ;
    
    Dmat[N-1][N-1] = + ( 2*((double) pow(N-1,2)) + 1 )/3 ;
    
    for(jj=1;jj<N-1;jj++) {
        
        Dmat[N-1][jj] = 2*((double) pow(-1,N+jj-1))/(1 - x[jj]) ;
        
    }
    
    Dmat[N-1][0] = + pow(-1,N-1) ;
    
    for(ii=1;ii<N-1;ii++) {
        
        Dmat[ii][0] = +((double) pow(-1,ii))/x[ii]/2 ;
        
    }
    
    for(ii=1;ii<N-1;ii++) {
        
        Dmat[ii][N-1] = - ((double) pow(-1,N+ii-1))/(1 - x[ii])/2 ;
        
    }
    
    for(ii=0;ii<N;ii++) {
        for(jj=0;jj<N;jj++) {
            
            D2mat[ii][jj] = 0. ;
            
            for(kk=0;kk<N;kk++) {
                D2mat[ii][jj] += Dmat[ii][kk]*Dmat[kk][jj] ;
            }
            
        }
    }
    
    
}





void unpackLich(void)
{
    int ii, jj ;
    
	for(ii=0;ii<5*N;ii++) {
        for(jj=0;jj<5*N;jj++) {
            
            Lmat[ jj*(5*N) + ii ] = Lich[ii][jj] ;
            
        }
    }
    
}



/* LAPACK solver */

void linsolve(double *x, double *b)
{
    int ii, Nvec, nrhs, ldLmat, ldx, info ;
    int ipiv[5*Nmax];
    
    
    unpackLich() ;
    
    Nvec    = 5*N ;
    nrhs = 1 ;
    ldLmat  = Nvec ;
    ldx  = Nvec ;
    
    for(ii=0;ii<Nvec;ii++) x[ii] = b[ii] ;
    
    dgesv_(&Nvec, &nrhs, Lmat, &ldLmat, ipiv, x, &ldx, &info);
    
    if(info != 0) {
        
        printf("\n\nFailure to solve linear system - %d\n\n", info);
        
        exit(1) ;
        
    }
    
    
}






